﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            Entities = new ObservableCollection<Entity>();
            InitializeComponent();
            ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            ultraGrid1.DataSource = Entities;
           
            Create(Entities, 6, 0, 10);
            this.ToString();
            DisplayName = DateTime.Now.ToString();
        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].RowLayoutStyle = Infragistics.Win.UltraWinGrid.RowLayoutStyle.GroupLayout;
            e.Layout.Override.AllowRowLayoutColMoving = Infragistics.Win.Layout.GridBagLayoutAllowMoving.AllowAll;
        }

        public ObservableCollection<Entity> Entities { get; private set; }
       
        public string DisplayName { get; private set; }
        void Create(ObservableCollection<Entity> list, int limit, int depth, int width)
        {
            depth++;
            if (depth >= limit)
            {
                return;
            }
            else
            {
                for (int i = 0; i < width; i++)
                {
                    Entity e = new Entity();
                    e.Name = string.Format("{0}.{1}", depth, i);
                    e.Property1 = string.Format("{0}.{1}", depth, i);
                    list.Add(e);
                    Create(e.Children, limit, depth, width);
                }
            }
        }
    }

    
    public class Entity
    {
        public Entity()
        {
            Children = new ObservableCollection<Entity>();
        }
        public string Name { get; set; }
        public string Property1 { get; set; }
        public ObservableCollection<Entity> Children { get; private set; }
    }
}
